/*
 * ESERCITAZIONE su LinkedList<E>:
 * ESPRESSIONE ALGEBRICA AD UNA VARIABILE RAPPRESENTATA COME LISTA DI TERMINI 
 * Esempio:  5x^6 + 12.5 x^3 -2 x^7 + 3 
 * Puo' essere rappresentata come lista di termini (coefficiente, esponente)
 * (5,6); (12.5,3); (-2,7); (3,0);
 */

import java.util.*;

public class ListaDiTermini {
  List<Termine> list = new LinkedList<Termine>( );

  public void insert(Termine x){
	list.add(x);
  }

  public void printList(){
	if (list.isEmpty()) return;
	Iterator<Termine> iterator = list.iterator(); 
	System.out.print(iterator.next());
	while (iterator.hasNext()) { 
		System.out.print(" + " + iterator.next()); 
	}
  }

  public String toString( ){
	String s = new String();
	if (list.isEmpty()) return s;
	Iterator<Termine> iterator = list.iterator(); 
	s += iterator.next().toString();
	while (iterator.hasNext()) { 
		s += " + " + iterator.next(); 
	}
	return s;
  }
  
  /*
  public String toString( ){
   //per ottenere una stringa "formattata" come una generica lista
		return list.toString(); 
	  }
   */



  public void sort(){
  // e.g., 4x^2 + 2x^9 + 3x^2 + x^3 + 6x^9 --> 3x^2 + 4x^2 + x^3 + 2x^9 + 6x^9 
	Collections.sort(list);
  }
  
  
  public void sort_decr(){
		Collections.sort(list, new Ord_decr());
	  }


  public void reduce(){
  // e.g., 4x^2 + 2x^9 + 3x^2 + x^3 + 6x^9 --> 7x^2 + x^3 + 8x^9 
	if (list.isEmpty()) return;
	Collections.sort(list);
	List<Termine> redList = new LinkedList<Termine>();
	Termine t1, t2;
	Iterator<Termine> itr = list.iterator(); 
	t1=itr.next();
	redList.add(t1);
	while (itr.hasNext()) {
		t2=itr.next();
		if (t1.getExp()==t2.getExp()) {
		    t1.setCoeff(t1.getCoeff() + t2.getCoeff());
		} else {
		    redList.add(t2);
		    t1 = t2;
		}
	}
	list=redList;

  }


  public static void main (String[ ] args) {
     	/**** GENERAZIONE ESPRESSIONE ALGEBRICA ****/	

	ListaDiTermini espressione = new ListaDiTermini( );
	espressione.insert(new Termine(2.0, 2));
	espressione.insert(new Termine(3.0, 2));
	espressione.insert(new Termine(5.0, 1));
	espressione.insert(new Termine(1.0, 0));
	espressione.insert(new Termine(-1, 2));
	espressione.insert(new Termine(2, 4));
	espressione.insert(new Termine(6, 1));

	espressione.printList();  //stampa 1
	
	espressione.sort_decr();
	System.out.println("\n\nEspressione ordinata in modo non crescente:\n" + espressione);  //stampa 1
	
	espressione.sort();
	System.out.println("\nEspressione ordinata in modo non decrescente:\n" + espressione);  //stampa 3

	espressione.reduce();
	System.out.println("\nEspressione ridotta:\n" + espressione);  //stampa 4

  } // method main

  

} // end-class 